# MSN-X
# Microsoft Netoworks Messenger Client for Xbox Media Center.
# Started  by Donno(donno45989@yahoo.com.au)

#Notes
# When running in the emu change the windowdialog to window
# When running the emulator - The screen won't display as it should on a tv. 


# At the moment It will auto login using the varibles below.
# Hopefull in futrue release it can ither read a text file or
# have no auto login - and u have to enter using the onscreen keyboard.
# for testing purpose I sugguest keeping the auto login for a while.
#msnusrname = "donno459@hotmail.com"
msnusrname = "xbmc_test@hotmail.com" # Decemeber 25 1925
msnpassword = "password"

import xbmc, xbmcgui
import msnp # - load the libary.
try: Emulating = xbmcgui.Emulating
except: Emulating = False

THE_TITLE = "MSN-X"
THE_VERSION = "0.02"

ACTION_UNKNOWN = 0			#'Y', black
ACTION_MOVE_LEFT = 1		#Dpad Left
ACTION_MOVE_RIGHT = 2		#Dpad Right
ACTION_MOVE_UP = 3			#Dpad Up
ACTION_MOVE_DOWN = 4		#Dpad Down
ACTION_SKIP_NEXT = 5 		#Left trigger
ACTION_SKIP_PREVIOUS = 6 	#Right trigger
ACTION_SELECT = 7			#'A'
ACTION_BACK = 9				#'B'
ACTION_MENU = 10			#'Back'
ACTION_STOP = 13			#'Start'
ACTION_DISPLAY = 18			#'X'

RootDir = "Q:\\scripts\\"	# Add the folder name of your script to the end of RootDir (i.e. "Q:\\scripts\\XMovieGuide\\")
PCRootDir = "E:\\sean\\MyWork\\xbox\\msn-x\\"
Script_Dir = "msnx\\"

if Emulating: RootDir = PCRootDir 
skin_name = "classic_" # this is here for now just for now until BitPLanes SkinLibary This is added or something else


#Settings , using 0 for no, 1 for yes
startmin = 1

# Until I or someone uses BitPLanes SkinLibary This will have to do
MINTOP = 30 # How much room should be left across the top
MINLEFT = 60
MINRIGHT = 60
MAXBOTTOM = 60  # How much room should be left across the bottom
MAXHEIGHT = 540

BUTTOM_HEIGHT = 35

BUDDY_WIDTH = 300

# alert box position
ALERT_X = MINLEFT 
ALERT_Y = MAXHEIGHT - 125

class gomsnx:
	def __init__(self):
		if startmin == 1:
			# Run Buddy List window
			budwin = BuddyList()
			budwin.doModal()
		else:
			pass # just for now 
			#Don't Show Anything Else.
		
#This class will be a dialog but the emulator has no dialog Window.
		# when xbox testing use WindowDialog
class BuddyList(xbmcgui.Window):
	def __init__(self):
		if Emulating: xbmcgui.Window.__init__(self)
		#Get the screen size
		global screenX
		global screenY
		screenX = self.getWidth()
		screenY = self.getHeight()
		# Begin setting up the GUI
		self.pic = xbmcgui.ControlImage(screenX - MINRIGHT - BUDDY_WIDTH , MINTOP ,BUDDY_WIDTH, MAXHEIGHT, RootDir + Script_Dir + skin_name + "buddybg.png")
		self.addControl(self.pic)
		# Newly Added not test - nxt 4 lines
		self.budlst = xbmcgui.ControlList(screenX - MINRIGHT - BUDDY_WIDTH + 15, MINTOP + 15 ,BUDDY_WIDTH - 15, MAXHEIGHT - 220)
		self.addControl(self.budlst)
		#two buttons at the bottom
		self.but_addcontact = xbmcgui.ControlButton(screenX - MINRIGHT - BUDDY_WIDTH + 15, MAXHEIGHT - 120 - BUTTOM_HEIGHT ,BUDDY_WIDTH - 15, BUTTOM_HEIGHT, "Add Contact")
		self.addControl(self.but_addcontact)
		self.but_quit = xbmcgui.ControlButton(screenX - MINRIGHT - BUDDY_WIDTH + 15, MAXHEIGHT - 120  , BUDDY_WIDTH - 15, BUTTOM_HEIGHT, "Quit")
		self.addControl(self.but_quit)
		#
		# button/list navigation 
		#
		self.budlst.addItem("Donno (donno459@hotmail.com)")
		self.setFocus(self.but_quit)
		#
		self.budlst.controlUp(self.but_quit)
		self.but_addcontact.controlUp(self.budlst)
		self.but_quit.controlUp(self.but_addcontact)
		
		self.budlst.controlDown(self.but_addcontact)
		self.but_addcontact.controlDown(self.but_quit)
		self.but_quit.controlDown(self.budlst)

	def onAction(self, action):
		print "Action button:", action
		if action == ACTION_MENU:
			self.quitme()
		if action == ACTION_DISPLAY:
			#on x / blue show option screen. Whatit to look like the mp3 irc script option.
			#priority above low
			pass
	def onControl(self, control):
		if control == self.but_quit:
			#User Selected Quit
			self.quitme()
		if control == self.but_addcontact:
			#Show Window which has the add contact screen - Priority - Low
			# Well I was going to show either a loating  (Dialog) window in the center_x center_y.
			# but i decided  until it works just show dialog boxs.
			dialog = xbmcgui.Dialog()
			if dialog.ok(THE_TITLE + " - Adding Contact", "Adding contact. \n Enter the email on the virtual keyboard."):
				newemail = unikeyboard("@hotmail.com")
				# now do the command to create a new contact by using the newemail varible

	
	def quitme(self):
		print "quit me" # debug only
		dialog = xbmcgui.Dialog()
		if dialog.yesno(THE_TITLE, "Select Yes if you want to completly close " + THE_TITLE + ". \n Select No if you want it to run in the background."):
			# User Selected Yes
			#discconect from server
			# and shut down the script
			self.close()
			# and close the gomsnx
		else:
			#Return to running in background - without a gui
			self.close() # so close this window.
	def unikeyboard(self, default):
		keyboard = xbmc.Keyboard(default)
		keyboard.doModal()
		if (keyboard.isConfirmed()):
			return keyboard.getText()
		else:
			return default
		
class AlertPopup(xbmcgui.Window):
	#THis class will be a dialog but the emulator has no dialog windo so wait for really xbox testing to set it.
	def __init__(self, style, email, text):
		if Emulating: xbmcgui.Window.__init__(self)
		# Show the little bg pic in corner.
		# ON this we need a button and a background
		self.bg = xbmcgui.ControlImage(ALERT_X, ALERT_Y, 0, 0, RootDir + Script_Dir + skin_name + "alert.png")
		self.addControl(self.bg)
		#self.but_alert = xbmcgui.ControlImage(0,0,0,0)
		#self.addControl(self.but_alert)
		#self.setFocus(self.but_alert)
		# Now need some code which will wait a few seoncds before killing this window.
		#
		# There are 2 different sytles
		# 1 -messages about ur self
		# 2 -message about other peoples stats
		# 3 -messages about messages.
		
		time.sleep(2)
	def onControl(self, control):
		if control == but_alert:
			#User Selected Alert, Now open chat window.
			pass
	def showAlert(style, email, text):
	# This will cause a PopUp to be shown.
		popup = AlertPopup()
		popup.doModal()
		del popupd
"""
# MsnListern should be the thing which generates and displays the alert popup
class MsnListener(SessionCallbacks):
    def state_changed(self, state):
        if state == msnp.States.ONLINE:
            print 'You are now online.'
            AlertPopup("1", "none", "You are now online"
class MsnChatListener(msnp.ChatCallbacks):
    def message_received(self, passport_id, display_name, text, charset):
        print '%s: %s' % (passport_id, text)
        self.chat.send_message(text, charset)
        # This at the moment sends info to debug then sends it back.

 """ #"""
#msn = msnp.Session(MyCallbacks())
#msn.login(msnusrname, msnpassword)


win = gomsnx()
#while True:
   # msn.process()
    #time.sleep(1)
    
win.doModal() # gomsnx has no doModal.
del win